//-----------------------MIXINS-FOR-HANDLING-THE-MEDIAQUERIES-MIXIN-FILE------------------------------//

//MIXINS
/*******/

//Description: useful to manage media queries and keep it maintainable
@mixin mq(
  $name: null,
  $media: all,
  $feature: "min-width",
  $orientation: null,
  $extendBaseMq: null
) {
  @if ($name == null) {
    @warn "mq(): Breakpoint size is null";
  }

  $mediaQuery: null;
  $remValue: null;
  $bp: map-get($breakpoints, $name);

  @if ($bp == null) {
    @warn "mq(): Breakpoint doesn't exist";
  }

  // the trix here is the division by 1 to remove the rem unit
  // according to https://sass-lang.com/documentation/modules/math the .div
  // function with value of the same unit will remove those unit
  // Also we remove the rem unit because it's better to use em in mediaqueries
  @if ($feature == "min-width") {
    $remValue: parseInt(math.div(($bp + $breakpoints-offset), $pixel-base)) +
      "em";
  } @else {
    $remValue: parseInt(math.div($bp, $pixel-base)) + "em";
  }

  @if ($orientation != null) {
    $mediaQuery: "#{$media} and (#{$feature}: #{$remValue}) and (orientation: #{$orientation})";
  } @else {
    $mediaQuery: "#{$media} and (#{$feature}: #{$remValue})";
  }

  @if ($extendBaseMq != null) {
    $mediaQuery: $mediaQuery + $extendBaseMq;
  }

  @media #{$mediaQuery} {
    @content;
  }
}

$pixel: 0.0625rem;

@mixin target-mq($name1: null, $name2: null, $extendBaseMq: null) {
  $bp1: map-get($breakpoints, $name1);
  $bp2: map-get($breakpoints, $name2);

  // the trix here is the division by 1 to remove the rem unit
  // according to https://sass-lang.com/documentation/modules/math the .div
  // function with value of the same unit will remove those unit
  // Also we remove the rem unit because it's better to use em in mediaqueries
  $remValue1: parseInt(math.div(($bp1 + $pixel), $pixel-base)) + "em";
  $remValue2: parseInt(
      math.div(($bp2 + $breakpoints-offset - $pixel), $pixel-base)
    ) + "em";

  $mediaQuery: "all and (min-width: #{$remValue1}) and (max-width: #{$remValue2})";

  @if ($extendBaseMq != null) {
    $mediaQuery: $mediaQuery + $extendBaseMq;
  }

  @media #{$mediaQuery} {
    @content;
  }
}
